#include <typeinfo>
#include <stdexcept>
#include <iostream>
#include <string>

template <typename T>
class DuplicateError : public std::logic_error
{
public:
	DuplicateError(const T&);
        string Typeid() const;
};


template <typename T>
std::string DuplicateError<T>::Typeid() const
{
    std::string id = typeid(T).name();

#ifdef _MSC_VER
	id = id.substr(6);  // for MSVC++ compiler remove first 6 char
#endif

#ifdef __GNUC__
	id = id.substr(id.find_first_not_of("0123456789"));
#endif

	return id;
}


template <typename T>
DuplicateError<T>::DuplicateError(const T& obj)
: std::logic_error(string("Duplicate ")+Typeid() + ": " +obj)
{}
